#include <iostream>
#include "compass.hpp"
#include <stdio.h>
#include <time.h>
#include <string>
#include <stdlib.h>
using namespace std;

    
    Compass::Compass(){
    }
    Compass::Compass(int input_port, Serial *cp){
        sensor = I2C(input_port,cp);
    }
    int Compass::setup(){
        sensor.sensor_type(LOWSPEED);
        Sleep(500);
        degree();
        degree();
        degree();//Otherwise the first measurement fails
        return 1;
    }  
    
    int Compass::degree(){
        char *answer;
        char command[2];
        command[0]= COMPASS_ADDRESS;
        command[1]= DEGREE;
        sensor.write(&command[0], 2, 2);
        if(sensor.wait_ans(2)){
             answer=sensor.read();
             return (0xff & answer[1])*2 + answer[2]; //returns unsigned value
        }
        return -1;
    }
    
    
    
    
    
    
    
