#include <iostream>
#include "adc_8591.hpp"
#include <stdio.h>
#include <time.h>
#include <string>
#include <stdlib.h>
using namespace std;

    
    ADC_8591::ADC_8591(){
    }
    
    ADC_8591::ADC_8591(int input_port,char adress, Serial *cp){
        sensor = I2C(input_port,cp);
        sensor_adress = adress;
    }
    
    int ADC_8591::setup(){
        sensor.sensor_type(LOWSPEED);
        Sleep(500);
        read_port(0x00);
        read_port(0x00);//Otherwise the first measurement fails
        return 1;
    }
    
   int ADC_8591::read_port(int port){
        char *answer;
        char command[2];
        command[0]=sensor_adress;
        command[1]=port%4;
        sensor.write(&command[0], 2, 1);
        if(sensor.wait_ans(1)){
            answer=sensor.read();
            return  0xff & answer[1]; //returns unsigned value
        }
        return -1;
   }
    
    
